;   PIC16F627A(PIC16F628A, PIC16F648A)
;--------------------------------------
;------------------------------------
;---------------------------------
;**************************************
;*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/
;/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*
;------------//////////////////////////
;CoPyRiGhT 2003 SoFtPrOgReSs /_\, 
;
; project ds1990a, 2004, 27 .
;---------_______________--------------
	include		p16f628.inc
	__config _WDT_ON & _MCLRE_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _LVP_OFF & _BODEN_OFF

;    4 !!!

 cblock 0x20
 dsdat0
 dsdat1
 dsdat2
 dsdat3
 dsdat4
 dsdat5
 dsdat6
 dsdat7
 var_01
 var_02
 var_03
 var_04
 var_05
 var_06
 _4del
 _ms_del
 endc

DQ		equ		4
Bp1		equ		2
Bp2		equ		3

;-------

		org 0x00
		movlw	b'00000111'
		movwf	CMCON		;  
		bcf		PORTA, 1	;!!!!!!!!!!!!!
		bcf 	STATUS, RP1
		bsf 	STATUS, RP0	;bank 1
		movlw	b'11110001'
		movwf	TRISA
		movlw	b'00000001'
		movwf	TRISB
		movlw	b'01111010'
		movwf	OPTION_REG
		bcf		STATUS, RP0	;bank 0

		movlw	d'50'
		movwf	var_01
start_test:
		btfsc	PORTB, 0	
		goto	d_start
		movlw	d'100'
		call 	_ms_delay
		decfsz	var_01, f
		goto	start_test
		call	_clean_eeprom ;   5 -  EEPROM
		
		movlw	d'114'
		movwf	var_01
		movlw	d'31'
		movwf	var_02
		movlw	d'2'
		movwf	var_03
		call	_sound
		movlw	d'67'
		call	_ms_delay
		call	_sound

d_start:
; ~72 
		sleep
;  	
		bcf		PORTA, DQ
		bsf		STATUS, RP0	;bank 1
		bcf		TRISA, DQ	;DQ - 
		bcf		STATUS, RP0	;bank 0
		movlw	d'124'		; 502 
		call	_4delay
		bsf		STATUS, RP0 ;bank 1
		bsf		TRISA, DQ	;DQ - 
		bcf		STATUS, RP0	;bank 0
		movlw	d'16'		; 70 
		call 	_4delay
		btfsc	PORTA, DQ	; DQ  ?
		goto	d_start		; -   
		movlw	d'106'		; 430 
		call	_4delay
		btfss	PORTA, DQ	; DQ  ?
		goto	d_start		; -   
		
			
;  "  "
		movlw	0x33		; 
		call	send_byte
;--------------------------------
;  ""  
		movlw 	dsdat0		;  
		movwf  	FSR
		movlw	d'8'		; 
		movwf	var_03
_next_rc_byte:
		call	receive_byte
		movwf	INDF
		incf	FSR, f
		decfsz	var_03, f
		goto	_next_rc_byte
	

		movf	dsdat0, f
		btfsc	STATUS, Z
		goto	_error_data
		
		
; CRC
		clrf	var_04
		movlw	d'7'
		movwf 	var_01
		movlw 	dsdat0
		movwf 	FSR
Next_byte:
        movlw   0x08
        movwf   var_02
		movf	INDF, w
		movwf 	var_03
DoCRC_Loop:
        xorwf   var_04, w
        movwf   var_05
        rrf     var_05, w
        movf    var_04, w
        btfsc   STATUS, C
        xorlw   b'00011000'
        movwf   var_05
        rrf     var_05, w
        movwf   var_04
        bcf     STATUS, C
        rrf     var_03, f
		movf    var_03, w
        decfsz  var_02, f
        goto    DoCRC_Loop
		incf 	FSR, f
		decfsz	var_01, f
		goto 	Next_byte
;  var_04 - crc  7- 
;   (. dsdat7)
		movf 	var_04, w
		xorwf 	dsdat7, w
		btfss 	STATUS, Z
		goto 	_error_data

		clrwdt			; wathdog 

		call	search_eeprom
		xorlw	0x01
		btfss	STATUS, Z
		goto	f_id

ok_id	call	_identify_ok
		goto	d_start
		
f_id	call	_identify_failed
		goto	d_start

search_eeprom:
;  EEPROM  
		clrw
		bsf		STATUS, RP0	;bank 1
		movwf	EEADR
		bsf		EECON1, RD
		movf	EEDATA, w
		bcf		STATUS, RP0	;bank 0
		movwf	var_01	; 
		movlw	0x01
		movwf	var_02	;  EEPROM
_next_sr:		
		movlw	d'6'
		movwf	var_03	;  
		movlw	dsdat1
		movwf	FSR
_st_cmp:
		movf	var_02, w	;  W
		bsf		STATUS, RP0	;bank 1
		movwf	EEADR		;W   
		bsf		EECON1, RD	; 
		movf	EEDATA, w	; EEPROM  W
		bcf		STATUS, RP0	;bank 0
		xorwf	INDF, w		;    
							; 
		btfsc	STATUS, Z	;?
		goto	_next_cmp	;,  
		movf	var_03, w	
		addwf	var_02, f	
		decfsz	var_01, f	;  ?
		goto	_next_sr	;,  
		clrw				;,     W=0
		goto	exit_se 
								
_next_cmp:
		incf	FSR, f		;   
		incf	var_02, f	;  EEPROM
		decfsz	var_03, f	;  ?
		goto	_st_cmp		;,  
							; -     W=1
		movlw	0x01
exit_se:		
		return

_identify_ok:
; " "
		movlw	d'45'		;556 Hz
		movwf	var_01	
		movlw	d'37'		;1/15 
		movwf	var_02
		movlw	d'2'
		movwf	var_03
		call	_sound
		movlw	d'40'		;625 Hz
		movwf	var_01
		movlw	d'42'		;1/15 
		movwf	var_02
		call	_sound
		movlw	d'67'		;
		call	_ms_delay	;
		movlw	d'30'		;833 Hz
		movwf	var_01
		movlw	d'111'		;1/7 
		movwf	var_02
		call	_sound
		movlw	d'15'
		movwf	var_01
		movlw	d'222'
		movwf	var_02
		call	_sound

		btfss	PORTB, 0		;!!!!!!!
		call	_write_serial	;!!!!!!!

		bsf		PORTA, 1

		movlw	d'7'
		movwf	dsdat0		;!!!! dsdat0
next_id_sound:
		movlw	d'14'
		movwf	var_01
		movlw	d'51'
		movwf	var_02
		movlw	d'14'
		movwf	var_03
		call	_sound
		movlw	d'100'
		call	_ms_delay
		decfsz	dsdat0, f
		goto	next_id_sound

		bcf		PORTA, 1
		
		return	
	
_identify_failed:
; "  "
		movlw	d'45'		;556 Hz
		movwf	var_01	
		movlw	d'37'		;1/15 
		movwf	var_02
		movlw	d'2'
		movwf	var_03
		call	_sound
		movlw	d'40'		;625 Hz
		movwf	var_01
		movlw	d'42'		;1/15 
		movwf	var_02
		call	_sound
		movlw	d'67'		;
		call	_ms_delay	;
		movlw	d'241'		;104 Hz
		movwf	var_01
		movlw	d'14'		;1/7 
		movwf	var_02
		call	_sound
		movlw	d'67'		;
		call	_ms_delay	;
		call	_sound

		btfss	PORTB, 0
		call	_write_serial

		movlw	d'7'
		movwf	var_01
		movlw	d'250'
		call	_ms_delay
		decfsz	var_01, f
		goto	$-3	
		
		return

;  
send_byte:
		movwf	var_01
		movlw	d'8'
		movwf	var_02		;  
next_tr_b:
		bcf		PORTA, DQ
		bsf		STATUS, RP0	;bank 1
		bcf		TRISA, DQ	;DQ - 
		bcf		STATUS, RP0	;bank 0
		nop
		nop
		rrf		var_01, f
		btfsc	STATUS, C
		goto	_set_in
		nop
		nop
		goto	_no_set_in
_set_in:
		bsf 	STATUS, RP0	;bank 1
		bsf		TRISA, DQ	;DQ - 
		bcf		STATUS, RP0 ;bank 0
_no_set_in:
		movlw	d'14'		; 62 
		call	_4delay
		bsf 	STATUS, RP0	;bank 1
		bsf		TRISA, DQ	;DQ - 
		bcf		STATUS, RP0 ;bank 0
		nop
		nop
		nop
		nop
		decfsz	var_02, f
		goto	next_tr_b
		return

;  
receive_byte:
		movlw	d'8'		
		movwf	var_01
		clrf	var_02
next_rc_b:	
		bcf		PORTA, DQ
		bsf		STATUS, RP0	;bank 1
		bcf		TRISA, DQ	;DQ - 
		bcf		STATUS, RP0	;bank 0
		nop
		nop
		nop
		nop
		nop
		nop
		bsf		STATUS, RP0 ;bank 1
		bsf		TRISA, DQ	;DQ - 
		bcf		STATUS, RP0	;bank 0
		nop
		nop
		nop	
		bcf 	STATUS, C
		btfsc	PORTA, DQ
		bsf		STATUS, C
		rrf		var_02, f
		movlw	d'11'		; 50 
		call	_4delay
		decfsz	var_01, f
		goto	next_rc_b
		movf	var_02, w
		return
		
;------____--------------
_error_data:
		movlw	d'223'
		movwf	var_01
		movlw	d'9'
		movwf	var_02
		movlw	d'2'
		movwf	var_03
		call	_sound
		goto 	d_start

; " "
;var1   (var1=FRm/4/20/2/FRs-4) FRm -  (Hz), FRs -  (Hz)
;var2  var3 -  . (var2*var3/2=FRs*dr) dr - , 
_sound:
		bsf		PORTA, Bp1
		bcf		PORTA, Bp2	
		movf	var_03, w
		movwf	var_06
_restore_cnt2:
		movf	var_02, w
		movwf	var_05
_restore_cnt1:
		movf	var_01, w
		movwf	var_04	
_dec_delay1:		
		nop
		nop
		nop
		movlw	d'3'
		call	_4delay
		decfsz	var_04, f
		goto 	_dec_delay1
		movlw	(1<<Bp1)+(1<<Bp2)
		xorwf	PORTA, f
		decfsz	var_05, f
		goto	_restore_cnt1
		decfsz	var_06, f
		goto	_restore_cnt2
		bcf		PORTA, Bp1
		bcf		PORTA, Bp2
		return	
		

;  ms
_ms_delay:
		movwf	_ms_del
_1000us:
		nop
		nop
		movlw	d'247'
		call	_4delay
		decfsz	_ms_del, f
		goto	_1000us
		return	
		
;  us
_4delay:
		movwf 	_4del
l4dl	clrwdt
		decfsz 	_4del, f
		goto 	l4dl
		return

_write_serial:
		movlw	dsdat1
		movwf	FSR
		bsf		STATUS, RP0 ;bank 1
		clrf	EEADR
		bsf		EECON1, RD
		movf	EEDATA, w
		bcf		STATUS, RP0; bank 0
		movwf	var_01	
		sublw	d'20'
		btfss	STATUS, C
		goto	_mem_full
		movf	var_01, w
		bcf		STATUS, C	;
		rlf		var_01, f	; var_01  6
		rlf		var_01, f	;-------//---------
		addwf	var_01, f	;------//---------
		addwf	var_01, f	;-----//---------
		incf	var_01, w	;var_01 +1
		bsf		STATUS, RP0	;bank 1
		bsf		EECON1, WREN
		movwf	EEADR
_next_byte:		
		movf	INDF, w	
		movwf	EEDATA
		call	_eeprom_write
		incf	EEADR, f
		incf	FSR, f
		movlw	dsdat7
		subwf	FSR, w
		btfss	STATUS, C
		goto	_next_byte
		bcf		EECON1, WREN
		clrf	EEADR
		bsf		EECON1, RD
		movf	EEDATA, w
		addlw	0x01
		bsf		EECON1, WREN
		movwf	EEDATA
		call	_eeprom_write
		bcf		EECON1, WREN
		bcf		STATUS, RP0 ;bank 0
		goto	exit_write_serial
_mem_full:
		movlw	d'30'
		movwf	var_01
		movlw	d'165'	
		movwf	var_02	
		movlw	d'2'
		movwf	var_03
		call	_sound
		movlw	d'67'		;
		call	_ms_delay	;
		movlw	d'34'
		movwf	var_01
		movlw	d'105'
		movwf	var_02
		call	_sound
		movlw	d'67'		;
		call	_ms_delay	;
		movlw	d'28'
		movwf	var_01
		movlw	d'178'
		movwf	var_02
		call	_sound
		movlw	d'67'		;
		call	_ms_delay	;
		movlw	d'45'
		movwf	var_01
		movlw	d'79'
		movwf	var_02
		call	_sound
exit_write_serial:
		return

_clean_eeprom:
		bsf		STATUS, RP0	;bank 1
		bsf 	EECON1, WREN		; 
		clrf	EEADR
		movlw	0x00
		movwf	EEDATA
		goto	_write_first
_nx_adr	movlw	0xFF
		movwf	EEDATA
_write_first:
		call 	_eeprom_write
		incf	EEADR, f
		movlw	0x80
		subwf	EEADR, w
		btfss	STATUS, C
		goto	_nx_adr
		bcf		EECON1, WREN		; 
		bcf		STATUS, RP0 ;bank 0
		return	
		

_eeprom_write:
;		bcf 	INTCON, GIE	; 
		clrwdt
		movlw 	0x55
		movwf 	EECON2
		movlw 	0xAA
		movwf 	EECON2
		bsf 	EECON1, WR
eewrts	btfsc 	EECON1, WR
		goto 	eewrts
		return



		org 0x2100
		DATA 	0x00

		end


